Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Reservation_station_transition.cpp	(revision 98)
@@ -25,30 +25,31 @@
       log_printf(TRACE,Reservation_station,FUNCTION,"  * Dump Reservation Station");  \
       for (uint32_t it_dump=0;it_dump<_param->_size_queue; it_dump++)   \
-        log_printf(TRACE,Reservation_station,FUNCTION,"    * [%.4d] %.2d %.2d %.2d %.4d, %.2d %.3d, %.2d %.2d, %.1d %.8x, %.4d %.1d %.8x, %.4d %.1d %.8x, %.4d %.1d %.2x, %.1d %.4d, %.1d %.4d (%s)", \
-                   it_dump,                                             \
-                   _queue[it_dump]._context_id           ,              \
-                   _queue[it_dump]._front_end_id         ,              \
-                   _queue[it_dump]._ooo_engine_id        ,              \
-                   _queue[it_dump]._rob_id               ,              \
-                   _queue[it_dump]._type                 ,              \
-                   _queue[it_dump]._operation            ,              \
-                   _queue[it_dump]._store_queue_ptr_write,              \
-                   _queue[it_dump]._load_queue_ptr_write ,              \
-                   _queue[it_dump]._has_immediat         ,              \
-                   _queue[it_dump]._immediat             ,              \
-                   _queue[it_dump]._num_reg_ra           ,              \
-                   _queue[it_dump]._data_ra_val          ,              \
-                   _queue[it_dump]._data_ra              ,              \
-                   _queue[it_dump]._num_reg_rb           ,              \
-                   _queue[it_dump]._data_rb_val          ,              \
-                   _queue[it_dump]._data_rb              ,              \
-                   _queue[it_dump]._num_reg_rc           ,              \
-                   _queue[it_dump]._data_rc_val          ,              \
-                   _queue[it_dump]._data_rc              ,              \
-                   _queue[it_dump]._write_rd             ,              \
-                   _queue[it_dump]._num_reg_rd           ,              \
-                   _queue[it_dump]._write_re             ,              \
-                   _queue[it_dump]._num_reg_re           ,              \
-                   toString(_queue[it_dump]._type).c_str());       \
+        if (_queue_valid [it_dump])                                     \
+          log_printf(TRACE,Reservation_station,FUNCTION,"    * [%.4d] %.2d %.2d %.2d %.4d, %.2d %.3d, %.2d %.2d, %.1d %.8x, %.4d %.1d %.8x, %.4d %.1d %.8x, %.4d %.1d %.2x, %.1d %.4d, %.1d %.4d (%s)", \
+                     it_dump,                                           \
+                     _queue[it_dump]._context_id           ,            \
+                     _queue[it_dump]._front_end_id         ,            \
+                     _queue[it_dump]._ooo_engine_id        ,            \
+                     _queue[it_dump]._rob_id               ,            \
+                     _queue[it_dump]._type                 ,            \
+                     _queue[it_dump]._operation            ,            \
+                     _queue[it_dump]._store_queue_ptr_write,            \
+                     _queue[it_dump]._load_queue_ptr_write ,            \
+                     _queue[it_dump]._has_immediat         ,            \
+                     _queue[it_dump]._immediat             ,            \
+                     _queue[it_dump]._num_reg_ra           ,            \
+                     _queue[it_dump]._data_ra_val          ,            \
+                     _queue[it_dump]._data_ra              ,            \
+                     _queue[it_dump]._num_reg_rb           ,            \
+                     _queue[it_dump]._data_rb_val          ,            \
+                     _queue[it_dump]._data_rb              ,            \
+                     _queue[it_dump]._num_reg_rc           ,            \
+                     _queue[it_dump]._data_rc_val          ,            \
+                     _queue[it_dump]._data_rc              ,            \
+                     _queue[it_dump]._write_rd             ,            \
+                     _queue[it_dump]._num_reg_rd           ,            \
+                     _queue[it_dump]._write_re             ,            \
+                     _queue[it_dump]._num_reg_re           ,            \
+                     toString(_queue[it_dump]._type).c_str());          \
     } while (0) 
 #else
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps	(revision 98)
@@ -13,4 +13,7 @@
 include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
+ifndef Queue
+include                         $(DIR_MORPHEO)/Behavioural/Generic/Queue/Makefile.deps
+endif
 
 #-----[ Directory ]----------------------------------------
@@ -20,7 +23,9 @@
 #-----[ Library ]------------------------------------------
 Execute_queue_LIBRARY		= 	-lExecute_queue	\
+					$(Queue_LIBRARY)	\
 					$(Behavioural_LIBRARY)	
 
 Execute_queue_DIR_LIBRARY	=	-L$(Execute_queue_DIR)/lib	\
+					$(Queue_DIR_LIBRARY) \
 					$(Behavioural_DIR_LIBRARY)
 
@@ -30,4 +35,5 @@
 				@\
 				$(MAKE) Behavioural_library; \
+				$(MAKE) Queue_library; \
 				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile;
 
@@ -35,3 +41,4 @@
 				@\
 				$(MAKE) Behavioural_library_clean; \
+				$(MAKE) Queue_library_clean; \
 				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/test.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/test.cpp	(revision 98)
@@ -7,5 +7,5 @@
  */
 
-#define NB_ITERATION  1
+#define NB_ITERATION  16
 #define CYCLE_MAX     (128*NB_ITERATION)
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h	(revision 98)
@@ -38,4 +38,5 @@
 //public : uint32_t            _size_ooo_engine_id           ;
 //public : uint32_t            _size_packet_id               ;
+  public : uint32_t            _size_internal_queue          ;
 
 //public : bool                _have_port_context_id         ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl.cpp	(revision 98)
@@ -9,4 +9,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Execute_queue.h"
 #include "Behavioural/include/Vhdl.h"
+#include "Behavioural/Generic/Queue/include/Queue.h"
 
 namespace morpheo                    {
@@ -25,4 +26,30 @@
   {
     log_printf(FUNC,Execute_queue,FUNCTION,"Begin");
+
+    //----- Queue -----
+   
+    morpheo::behavioural::generic::queue::Parameters * param_queue;
+    morpheo::behavioural::generic::queue::Queue      * queue;
+    
+    param_queue = new morpheo::behavioural::generic::queue::Parameters
+      (_param->_size_queue,
+       _param->_size_internal_queue
+       );
+    
+    std::string queue_name = _name + "_queue";
+    queue = new morpheo::behavioural::generic::queue::Queue
+      (queue_name.c_str()
+#ifdef STATISTICS
+       ,NULL
+#endif
+       ,param_queue
+       ,USE_VHDL);
+    
+    _component->set_component(queue->_component
+#ifdef POSITION
+                              , 0, 0, 0, 0
+#endif
+                              , INSTANCE_LIBRARY
+                              );
 
     Vhdl * vhdl = new Vhdl (_name);
